package com.fr.plugin.sso.config.simple.account;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.record.analyzer.EnableMetrics;

@Visualization(category = "单点登录配置")
@EnableMetrics
public class PluginSimpleConfig extends DefaultConfiguration {

    private static volatile PluginSimpleConfig config = null;

    @Focus(id="com.fr.plugin.sso.config.simple", text = "单点登录配置", source = Original.PLUGIN)
    public static PluginSimpleConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(PluginSimpleConfig.class);
        }
        return config;
    }

    @Identifier(value = "单点env和url配置", name = "单点env和url配置", description = "格式env1,url1;env2,url2", status = Status.SHOW)
    private Conf<String> url = Holders.simple("env1,url1;env2,url2");

    public String getUrl() {
        return url.get();
    }

    public void setUrl(String url) {
        this.url.set(url);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        PluginSimpleConfig cloned = (PluginSimpleConfig) super.clone();
//        cloned.text = (Conf<String>) text.clone();
//        cloned.count = (Conf<Integer>) count.clone();
//        cloned.price = (Conf<Double>) price.clone();
//        cloned.time = (Conf<Long>) time.clone();
//        cloned.student = (Conf<Boolean>) student.clone();
        return cloned;
    }

}
